# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 5.8.0
    Contact: support@termlex.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus.com.termlex.pathnexus.model.address import Address  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.boolean_type import BooleanType  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.code_type import CodeType  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.codeable_concept import CodeableConcept  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.contact_point import ContactPoint  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.endpoint import Endpoint  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.extension import Extension  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.id_type import IdType  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.identifier import Identifier  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.meta import Meta  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.narrative import Narrative  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.organization import Organization  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.organization_contact_component import OrganizationContactComponent  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.reference import Reference  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.resource import Resource  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.string_type import StringType  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.uri_type import UriType  # noqa: F401,E501


class Organization(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'format_comments_pre': 'list[str]',
        'format_comments_post': 'list[str]',
        'id': 'str',
        'meta': 'Meta',
        'implicit_rules': 'str',
        'language': 'str',
        'text': 'Narrative',
        'contained': 'list[Resource]',
        'extension': 'list[Extension]',
        'modifier_extension': 'list[Extension]',
        'identifier': 'list[Identifier]',
        'active': 'bool',
        'type': 'list[CodeableConcept]',
        'name': 'str',
        'alias': 'list[StringType]',
        'telecom': 'list[ContactPoint]',
        'address': 'list[Address]',
        'part_of': 'Reference',
        'part_of_target': 'Organization',
        'contact': 'list[OrganizationContactComponent]',
        'endpoint': 'list[Reference]',
        'endpoint_target': 'list[Endpoint]',
        'address_first_rep': 'Address',
        'endpoint_first_rep': 'Reference',
        'active_element': 'BooleanType',
        'resource_type': 'str',
        'telecom_first_rep': 'ContactPoint',
        'name_element': 'StringType',
        'contact_first_rep': 'OrganizationContactComponent',
        'type_first_rep': 'CodeableConcept',
        'identifier_first_rep': 'Identifier',
        'empty': 'bool',
        'id_element': 'IdType',
        'language_element': 'CodeType',
        'structure_fhir_version_enum': 'str',
        'implicit_rules_element': 'UriType',
        'id_base': 'str',
        'resource': 'bool',
        'boolean_primitive': 'bool',
        'date_time': 'bool',
        'primitive': 'bool'
    }

    attribute_map = {
        'format_comments_pre': 'formatCommentsPre',
        'format_comments_post': 'formatCommentsPost',
        'id': 'id',
        'meta': 'meta',
        'implicit_rules': 'implicitRules',
        'language': 'language',
        'text': 'text',
        'contained': 'contained',
        'extension': 'extension',
        'modifier_extension': 'modifierExtension',
        'identifier': 'identifier',
        'active': 'active',
        'type': 'type',
        'name': 'name',
        'alias': 'alias',
        'telecom': 'telecom',
        'address': 'address',
        'part_of': 'partOf',
        'part_of_target': 'partOfTarget',
        'contact': 'contact',
        'endpoint': 'endpoint',
        'endpoint_target': 'endpointTarget',
        'address_first_rep': 'addressFirstRep',
        'endpoint_first_rep': 'endpointFirstRep',
        'active_element': 'activeElement',
        'resource_type': 'resourceType',
        'telecom_first_rep': 'telecomFirstRep',
        'name_element': 'nameElement',
        'contact_first_rep': 'contactFirstRep',
        'type_first_rep': 'typeFirstRep',
        'identifier_first_rep': 'identifierFirstRep',
        'empty': 'empty',
        'id_element': 'idElement',
        'language_element': 'languageElement',
        'structure_fhir_version_enum': 'structureFhirVersionEnum',
        'implicit_rules_element': 'implicitRulesElement',
        'id_base': 'idBase',
        'resource': 'resource',
        'boolean_primitive': 'booleanPrimitive',
        'date_time': 'dateTime',
        'primitive': 'primitive'
    }

    def __init__(self, format_comments_pre=None, format_comments_post=None, id=None, meta=None, implicit_rules=None, language=None, text=None, contained=None, extension=None, modifier_extension=None, identifier=None, active=None, type=None, name=None, alias=None, telecom=None, address=None, part_of=None, part_of_target=None, contact=None, endpoint=None, endpoint_target=None, address_first_rep=None, endpoint_first_rep=None, active_element=None, resource_type=None, telecom_first_rep=None, name_element=None, contact_first_rep=None, type_first_rep=None, identifier_first_rep=None, empty=None, id_element=None, language_element=None, structure_fhir_version_enum=None, implicit_rules_element=None, id_base=None, resource=None, boolean_primitive=None, date_time=None, primitive=None):  # noqa: E501
        """Organization - a model defined in Swagger"""  # noqa: E501

        self._format_comments_pre = None
        self._format_comments_post = None
        self._id = None
        self._meta = None
        self._implicit_rules = None
        self._language = None
        self._text = None
        self._contained = None
        self._extension = None
        self._modifier_extension = None
        self._identifier = None
        self._active = None
        self._type = None
        self._name = None
        self._alias = None
        self._telecom = None
        self._address = None
        self._part_of = None
        self._part_of_target = None
        self._contact = None
        self._endpoint = None
        self._endpoint_target = None
        self._address_first_rep = None
        self._endpoint_first_rep = None
        self._active_element = None
        self._resource_type = None
        self._telecom_first_rep = None
        self._name_element = None
        self._contact_first_rep = None
        self._type_first_rep = None
        self._identifier_first_rep = None
        self._empty = None
        self._id_element = None
        self._language_element = None
        self._structure_fhir_version_enum = None
        self._implicit_rules_element = None
        self._id_base = None
        self._resource = None
        self._boolean_primitive = None
        self._date_time = None
        self._primitive = None
        self.discriminator = None

        if format_comments_pre is not None:
            self.format_comments_pre = format_comments_pre
        if format_comments_post is not None:
            self.format_comments_post = format_comments_post
        if id is not None:
            self.id = id
        if meta is not None:
            self.meta = meta
        if implicit_rules is not None:
            self.implicit_rules = implicit_rules
        if language is not None:
            self.language = language
        if text is not None:
            self.text = text
        if contained is not None:
            self.contained = contained
        if extension is not None:
            self.extension = extension
        if modifier_extension is not None:
            self.modifier_extension = modifier_extension
        if identifier is not None:
            self.identifier = identifier
        if active is not None:
            self.active = active
        if type is not None:
            self.type = type
        if name is not None:
            self.name = name
        if alias is not None:
            self.alias = alias
        if telecom is not None:
            self.telecom = telecom
        if address is not None:
            self.address = address
        if part_of is not None:
            self.part_of = part_of
        if part_of_target is not None:
            self.part_of_target = part_of_target
        if contact is not None:
            self.contact = contact
        if endpoint is not None:
            self.endpoint = endpoint
        if endpoint_target is not None:
            self.endpoint_target = endpoint_target
        if address_first_rep is not None:
            self.address_first_rep = address_first_rep
        if endpoint_first_rep is not None:
            self.endpoint_first_rep = endpoint_first_rep
        if active_element is not None:
            self.active_element = active_element
        if resource_type is not None:
            self.resource_type = resource_type
        if telecom_first_rep is not None:
            self.telecom_first_rep = telecom_first_rep
        if name_element is not None:
            self.name_element = name_element
        if contact_first_rep is not None:
            self.contact_first_rep = contact_first_rep
        if type_first_rep is not None:
            self.type_first_rep = type_first_rep
        if identifier_first_rep is not None:
            self.identifier_first_rep = identifier_first_rep
        if empty is not None:
            self.empty = empty
        if id_element is not None:
            self.id_element = id_element
        if language_element is not None:
            self.language_element = language_element
        if structure_fhir_version_enum is not None:
            self.structure_fhir_version_enum = structure_fhir_version_enum
        if implicit_rules_element is not None:
            self.implicit_rules_element = implicit_rules_element
        if id_base is not None:
            self.id_base = id_base
        if resource is not None:
            self.resource = resource
        if boolean_primitive is not None:
            self.boolean_primitive = boolean_primitive
        if date_time is not None:
            self.date_time = date_time
        if primitive is not None:
            self.primitive = primitive

    @property
    def format_comments_pre(self):
        """Gets the format_comments_pre of this Organization.  # noqa: E501


        :return: The format_comments_pre of this Organization.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_pre

    @format_comments_pre.setter
    def format_comments_pre(self, format_comments_pre):
        """Sets the format_comments_pre of this Organization.


        :param format_comments_pre: The format_comments_pre of this Organization.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_pre = format_comments_pre

    @property
    def format_comments_post(self):
        """Gets the format_comments_post of this Organization.  # noqa: E501


        :return: The format_comments_post of this Organization.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_post

    @format_comments_post.setter
    def format_comments_post(self, format_comments_post):
        """Sets the format_comments_post of this Organization.


        :param format_comments_post: The format_comments_post of this Organization.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_post = format_comments_post

    @property
    def id(self):
        """Gets the id of this Organization.  # noqa: E501


        :return: The id of this Organization.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Organization.


        :param id: The id of this Organization.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def meta(self):
        """Gets the meta of this Organization.  # noqa: E501


        :return: The meta of this Organization.  # noqa: E501
        :rtype: Meta
        """
        return self._meta

    @meta.setter
    def meta(self, meta):
        """Sets the meta of this Organization.


        :param meta: The meta of this Organization.  # noqa: E501
        :type: Meta
        """

        self._meta = meta

    @property
    def implicit_rules(self):
        """Gets the implicit_rules of this Organization.  # noqa: E501


        :return: The implicit_rules of this Organization.  # noqa: E501
        :rtype: str
        """
        return self._implicit_rules

    @implicit_rules.setter
    def implicit_rules(self, implicit_rules):
        """Sets the implicit_rules of this Organization.


        :param implicit_rules: The implicit_rules of this Organization.  # noqa: E501
        :type: str
        """

        self._implicit_rules = implicit_rules

    @property
    def language(self):
        """Gets the language of this Organization.  # noqa: E501


        :return: The language of this Organization.  # noqa: E501
        :rtype: str
        """
        return self._language

    @language.setter
    def language(self, language):
        """Sets the language of this Organization.


        :param language: The language of this Organization.  # noqa: E501
        :type: str
        """

        self._language = language

    @property
    def text(self):
        """Gets the text of this Organization.  # noqa: E501


        :return: The text of this Organization.  # noqa: E501
        :rtype: Narrative
        """
        return self._text

    @text.setter
    def text(self, text):
        """Sets the text of this Organization.


        :param text: The text of this Organization.  # noqa: E501
        :type: Narrative
        """

        self._text = text

    @property
    def contained(self):
        """Gets the contained of this Organization.  # noqa: E501


        :return: The contained of this Organization.  # noqa: E501
        :rtype: list[Resource]
        """
        return self._contained

    @contained.setter
    def contained(self, contained):
        """Sets the contained of this Organization.


        :param contained: The contained of this Organization.  # noqa: E501
        :type: list[Resource]
        """

        self._contained = contained

    @property
    def extension(self):
        """Gets the extension of this Organization.  # noqa: E501


        :return: The extension of this Organization.  # noqa: E501
        :rtype: list[Extension]
        """
        return self._extension

    @extension.setter
    def extension(self, extension):
        """Sets the extension of this Organization.


        :param extension: The extension of this Organization.  # noqa: E501
        :type: list[Extension]
        """

        self._extension = extension

    @property
    def modifier_extension(self):
        """Gets the modifier_extension of this Organization.  # noqa: E501


        :return: The modifier_extension of this Organization.  # noqa: E501
        :rtype: list[Extension]
        """
        return self._modifier_extension

    @modifier_extension.setter
    def modifier_extension(self, modifier_extension):
        """Sets the modifier_extension of this Organization.


        :param modifier_extension: The modifier_extension of this Organization.  # noqa: E501
        :type: list[Extension]
        """

        self._modifier_extension = modifier_extension

    @property
    def identifier(self):
        """Gets the identifier of this Organization.  # noqa: E501


        :return: The identifier of this Organization.  # noqa: E501
        :rtype: list[Identifier]
        """
        return self._identifier

    @identifier.setter
    def identifier(self, identifier):
        """Sets the identifier of this Organization.


        :param identifier: The identifier of this Organization.  # noqa: E501
        :type: list[Identifier]
        """

        self._identifier = identifier

    @property
    def active(self):
        """Gets the active of this Organization.  # noqa: E501


        :return: The active of this Organization.  # noqa: E501
        :rtype: bool
        """
        return self._active

    @active.setter
    def active(self, active):
        """Sets the active of this Organization.


        :param active: The active of this Organization.  # noqa: E501
        :type: bool
        """

        self._active = active

    @property
    def type(self):
        """Gets the type of this Organization.  # noqa: E501


        :return: The type of this Organization.  # noqa: E501
        :rtype: list[CodeableConcept]
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Organization.


        :param type: The type of this Organization.  # noqa: E501
        :type: list[CodeableConcept]
        """

        self._type = type

    @property
    def name(self):
        """Gets the name of this Organization.  # noqa: E501


        :return: The name of this Organization.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Organization.


        :param name: The name of this Organization.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def alias(self):
        """Gets the alias of this Organization.  # noqa: E501


        :return: The alias of this Organization.  # noqa: E501
        :rtype: list[StringType]
        """
        return self._alias

    @alias.setter
    def alias(self, alias):
        """Sets the alias of this Organization.


        :param alias: The alias of this Organization.  # noqa: E501
        :type: list[StringType]
        """

        self._alias = alias

    @property
    def telecom(self):
        """Gets the telecom of this Organization.  # noqa: E501


        :return: The telecom of this Organization.  # noqa: E501
        :rtype: list[ContactPoint]
        """
        return self._telecom

    @telecom.setter
    def telecom(self, telecom):
        """Sets the telecom of this Organization.


        :param telecom: The telecom of this Organization.  # noqa: E501
        :type: list[ContactPoint]
        """

        self._telecom = telecom

    @property
    def address(self):
        """Gets the address of this Organization.  # noqa: E501


        :return: The address of this Organization.  # noqa: E501
        :rtype: list[Address]
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this Organization.


        :param address: The address of this Organization.  # noqa: E501
        :type: list[Address]
        """

        self._address = address

    @property
    def part_of(self):
        """Gets the part_of of this Organization.  # noqa: E501


        :return: The part_of of this Organization.  # noqa: E501
        :rtype: Reference
        """
        return self._part_of

    @part_of.setter
    def part_of(self, part_of):
        """Sets the part_of of this Organization.


        :param part_of: The part_of of this Organization.  # noqa: E501
        :type: Reference
        """

        self._part_of = part_of

    @property
    def part_of_target(self):
        """Gets the part_of_target of this Organization.  # noqa: E501


        :return: The part_of_target of this Organization.  # noqa: E501
        :rtype: Organization
        """
        return self._part_of_target

    @part_of_target.setter
    def part_of_target(self, part_of_target):
        """Sets the part_of_target of this Organization.


        :param part_of_target: The part_of_target of this Organization.  # noqa: E501
        :type: Organization
        """

        self._part_of_target = part_of_target

    @property
    def contact(self):
        """Gets the contact of this Organization.  # noqa: E501


        :return: The contact of this Organization.  # noqa: E501
        :rtype: list[OrganizationContactComponent]
        """
        return self._contact

    @contact.setter
    def contact(self, contact):
        """Sets the contact of this Organization.


        :param contact: The contact of this Organization.  # noqa: E501
        :type: list[OrganizationContactComponent]
        """

        self._contact = contact

    @property
    def endpoint(self):
        """Gets the endpoint of this Organization.  # noqa: E501


        :return: The endpoint of this Organization.  # noqa: E501
        :rtype: list[Reference]
        """
        return self._endpoint

    @endpoint.setter
    def endpoint(self, endpoint):
        """Sets the endpoint of this Organization.


        :param endpoint: The endpoint of this Organization.  # noqa: E501
        :type: list[Reference]
        """

        self._endpoint = endpoint

    @property
    def endpoint_target(self):
        """Gets the endpoint_target of this Organization.  # noqa: E501


        :return: The endpoint_target of this Organization.  # noqa: E501
        :rtype: list[Endpoint]
        """
        return self._endpoint_target

    @endpoint_target.setter
    def endpoint_target(self, endpoint_target):
        """Sets the endpoint_target of this Organization.


        :param endpoint_target: The endpoint_target of this Organization.  # noqa: E501
        :type: list[Endpoint]
        """

        self._endpoint_target = endpoint_target

    @property
    def address_first_rep(self):
        """Gets the address_first_rep of this Organization.  # noqa: E501


        :return: The address_first_rep of this Organization.  # noqa: E501
        :rtype: Address
        """
        return self._address_first_rep

    @address_first_rep.setter
    def address_first_rep(self, address_first_rep):
        """Sets the address_first_rep of this Organization.


        :param address_first_rep: The address_first_rep of this Organization.  # noqa: E501
        :type: Address
        """

        self._address_first_rep = address_first_rep

    @property
    def endpoint_first_rep(self):
        """Gets the endpoint_first_rep of this Organization.  # noqa: E501


        :return: The endpoint_first_rep of this Organization.  # noqa: E501
        :rtype: Reference
        """
        return self._endpoint_first_rep

    @endpoint_first_rep.setter
    def endpoint_first_rep(self, endpoint_first_rep):
        """Sets the endpoint_first_rep of this Organization.


        :param endpoint_first_rep: The endpoint_first_rep of this Organization.  # noqa: E501
        :type: Reference
        """

        self._endpoint_first_rep = endpoint_first_rep

    @property
    def active_element(self):
        """Gets the active_element of this Organization.  # noqa: E501


        :return: The active_element of this Organization.  # noqa: E501
        :rtype: BooleanType
        """
        return self._active_element

    @active_element.setter
    def active_element(self, active_element):
        """Sets the active_element of this Organization.


        :param active_element: The active_element of this Organization.  # noqa: E501
        :type: BooleanType
        """

        self._active_element = active_element

    @property
    def resource_type(self):
        """Gets the resource_type of this Organization.  # noqa: E501


        :return: The resource_type of this Organization.  # noqa: E501
        :rtype: str
        """
        return self._resource_type

    @resource_type.setter
    def resource_type(self, resource_type):
        """Sets the resource_type of this Organization.


        :param resource_type: The resource_type of this Organization.  # noqa: E501
        :type: str
        """
        allowed_values = ["Account", "ActivityDefinition", "AdverseEvent", "AllergyIntolerance", "Appointment", "AppointmentResponse", "AuditEvent", "Basic", "Binary", "BiologicallyDerivedProduct", "BodyStructure", "Bundle", "CapabilityStatement", "CarePlan", "CareTeam", "CatalogEntry", "ChargeItem", "ChargeItemDefinition", "Claim", "ClaimResponse", "ClinicalImpression", "CodeSystem", "Communication", "CommunicationRequest", "CompartmentDefinition", "Composition", "ConceptMap", "Condition", "Consent", "Contract", "Coverage", "CoverageEligibilityRequest", "CoverageEligibilityResponse", "DetectedIssue", "Device", "DeviceDefinition", "DeviceMetric", "DeviceRequest", "DeviceUseStatement", "DiagnosticReport", "DocumentManifest", "DocumentReference", "EffectEvidenceSynthesis", "Encounter", "Endpoint", "EnrollmentRequest", "EnrollmentResponse", "EpisodeOfCare", "EventDefinition", "Evidence", "EvidenceVariable", "ExampleScenario", "ExplanationOfBenefit", "FamilyMemberHistory", "Flag", "Goal", "GraphDefinition", "Group", "GuidanceResponse", "HealthcareService", "ImagingStudy", "Immunization", "ImmunizationEvaluation", "ImmunizationRecommendation", "ImplementationGuide", "InsurancePlan", "Invoice", "Library", "Linkage", "List", "Location", "Measure", "MeasureReport", "Media", "Medication", "MedicationAdministration", "MedicationDispense", "MedicationKnowledge", "MedicationRequest", "MedicationStatement", "MedicinalProduct", "MedicinalProductAuthorization", "MedicinalProductContraindication", "MedicinalProductIndication", "MedicinalProductIngredient", "MedicinalProductInteraction", "MedicinalProductManufactured", "MedicinalProductPackaged", "MedicinalProductPharmaceutical", "MedicinalProductUndesirableEffect", "MessageDefinition", "MessageHeader", "MolecularSequence", "NamingSystem", "NutritionOrder", "Observation", "ObservationDefinition", "OperationDefinition", "OperationOutcome", "Organization", "OrganizationAffiliation", "Parameters", "Patient", "PaymentNotice", "PaymentReconciliation", "Person", "PlanDefinition", "Practitioner", "PractitionerRole", "Procedure", "Provenance", "Questionnaire", "QuestionnaireResponse", "RelatedPerson", "RequestGroup", "ResearchDefinition", "ResearchElementDefinition", "ResearchStudy", "ResearchSubject", "RiskAssessment", "RiskEvidenceSynthesis", "Schedule", "SearchParameter", "ServiceRequest", "Slot", "Specimen", "SpecimenDefinition", "StructureDefinition", "StructureMap", "Subscription", "Substance", "SubstanceNucleicAcid", "SubstancePolymer", "SubstanceProtein", "SubstanceReferenceInformation", "SubstanceSourceMaterial", "SubstanceSpecification", "SupplyDelivery", "SupplyRequest", "Task", "TerminologyCapabilities", "TestReport", "TestScript", "ValueSet", "VerificationResult", "VisionPrescription"]  # noqa: E501
        if resource_type not in allowed_values:
            raise ValueError(
                "Invalid value for `resource_type` ({0}), must be one of {1}"  # noqa: E501
                .format(resource_type, allowed_values)
            )

        self._resource_type = resource_type

    @property
    def telecom_first_rep(self):
        """Gets the telecom_first_rep of this Organization.  # noqa: E501


        :return: The telecom_first_rep of this Organization.  # noqa: E501
        :rtype: ContactPoint
        """
        return self._telecom_first_rep

    @telecom_first_rep.setter
    def telecom_first_rep(self, telecom_first_rep):
        """Sets the telecom_first_rep of this Organization.


        :param telecom_first_rep: The telecom_first_rep of this Organization.  # noqa: E501
        :type: ContactPoint
        """

        self._telecom_first_rep = telecom_first_rep

    @property
    def name_element(self):
        """Gets the name_element of this Organization.  # noqa: E501


        :return: The name_element of this Organization.  # noqa: E501
        :rtype: StringType
        """
        return self._name_element

    @name_element.setter
    def name_element(self, name_element):
        """Sets the name_element of this Organization.


        :param name_element: The name_element of this Organization.  # noqa: E501
        :type: StringType
        """

        self._name_element = name_element

    @property
    def contact_first_rep(self):
        """Gets the contact_first_rep of this Organization.  # noqa: E501


        :return: The contact_first_rep of this Organization.  # noqa: E501
        :rtype: OrganizationContactComponent
        """
        return self._contact_first_rep

    @contact_first_rep.setter
    def contact_first_rep(self, contact_first_rep):
        """Sets the contact_first_rep of this Organization.


        :param contact_first_rep: The contact_first_rep of this Organization.  # noqa: E501
        :type: OrganizationContactComponent
        """

        self._contact_first_rep = contact_first_rep

    @property
    def type_first_rep(self):
        """Gets the type_first_rep of this Organization.  # noqa: E501


        :return: The type_first_rep of this Organization.  # noqa: E501
        :rtype: CodeableConcept
        """
        return self._type_first_rep

    @type_first_rep.setter
    def type_first_rep(self, type_first_rep):
        """Sets the type_first_rep of this Organization.


        :param type_first_rep: The type_first_rep of this Organization.  # noqa: E501
        :type: CodeableConcept
        """

        self._type_first_rep = type_first_rep

    @property
    def identifier_first_rep(self):
        """Gets the identifier_first_rep of this Organization.  # noqa: E501


        :return: The identifier_first_rep of this Organization.  # noqa: E501
        :rtype: Identifier
        """
        return self._identifier_first_rep

    @identifier_first_rep.setter
    def identifier_first_rep(self, identifier_first_rep):
        """Sets the identifier_first_rep of this Organization.


        :param identifier_first_rep: The identifier_first_rep of this Organization.  # noqa: E501
        :type: Identifier
        """

        self._identifier_first_rep = identifier_first_rep

    @property
    def empty(self):
        """Gets the empty of this Organization.  # noqa: E501


        :return: The empty of this Organization.  # noqa: E501
        :rtype: bool
        """
        return self._empty

    @empty.setter
    def empty(self, empty):
        """Sets the empty of this Organization.


        :param empty: The empty of this Organization.  # noqa: E501
        :type: bool
        """

        self._empty = empty

    @property
    def id_element(self):
        """Gets the id_element of this Organization.  # noqa: E501


        :return: The id_element of this Organization.  # noqa: E501
        :rtype: IdType
        """
        return self._id_element

    @id_element.setter
    def id_element(self, id_element):
        """Sets the id_element of this Organization.


        :param id_element: The id_element of this Organization.  # noqa: E501
        :type: IdType
        """

        self._id_element = id_element

    @property
    def language_element(self):
        """Gets the language_element of this Organization.  # noqa: E501


        :return: The language_element of this Organization.  # noqa: E501
        :rtype: CodeType
        """
        return self._language_element

    @language_element.setter
    def language_element(self, language_element):
        """Sets the language_element of this Organization.


        :param language_element: The language_element of this Organization.  # noqa: E501
        :type: CodeType
        """

        self._language_element = language_element

    @property
    def structure_fhir_version_enum(self):
        """Gets the structure_fhir_version_enum of this Organization.  # noqa: E501


        :return: The structure_fhir_version_enum of this Organization.  # noqa: E501
        :rtype: str
        """
        return self._structure_fhir_version_enum

    @structure_fhir_version_enum.setter
    def structure_fhir_version_enum(self, structure_fhir_version_enum):
        """Sets the structure_fhir_version_enum of this Organization.


        :param structure_fhir_version_enum: The structure_fhir_version_enum of this Organization.  # noqa: E501
        :type: str
        """
        allowed_values = ["DSTU2", "DSTU2_HL7ORG", "DSTU2_1", "DSTU3", "R4", "R5"]  # noqa: E501
        if structure_fhir_version_enum not in allowed_values:
            raise ValueError(
                "Invalid value for `structure_fhir_version_enum` ({0}), must be one of {1}"  # noqa: E501
                .format(structure_fhir_version_enum, allowed_values)
            )

        self._structure_fhir_version_enum = structure_fhir_version_enum

    @property
    def implicit_rules_element(self):
        """Gets the implicit_rules_element of this Organization.  # noqa: E501


        :return: The implicit_rules_element of this Organization.  # noqa: E501
        :rtype: UriType
        """
        return self._implicit_rules_element

    @implicit_rules_element.setter
    def implicit_rules_element(self, implicit_rules_element):
        """Sets the implicit_rules_element of this Organization.


        :param implicit_rules_element: The implicit_rules_element of this Organization.  # noqa: E501
        :type: UriType
        """

        self._implicit_rules_element = implicit_rules_element

    @property
    def id_base(self):
        """Gets the id_base of this Organization.  # noqa: E501


        :return: The id_base of this Organization.  # noqa: E501
        :rtype: str
        """
        return self._id_base

    @id_base.setter
    def id_base(self, id_base):
        """Sets the id_base of this Organization.


        :param id_base: The id_base of this Organization.  # noqa: E501
        :type: str
        """

        self._id_base = id_base

    @property
    def resource(self):
        """Gets the resource of this Organization.  # noqa: E501


        :return: The resource of this Organization.  # noqa: E501
        :rtype: bool
        """
        return self._resource

    @resource.setter
    def resource(self, resource):
        """Sets the resource of this Organization.


        :param resource: The resource of this Organization.  # noqa: E501
        :type: bool
        """

        self._resource = resource

    @property
    def boolean_primitive(self):
        """Gets the boolean_primitive of this Organization.  # noqa: E501


        :return: The boolean_primitive of this Organization.  # noqa: E501
        :rtype: bool
        """
        return self._boolean_primitive

    @boolean_primitive.setter
    def boolean_primitive(self, boolean_primitive):
        """Sets the boolean_primitive of this Organization.


        :param boolean_primitive: The boolean_primitive of this Organization.  # noqa: E501
        :type: bool
        """

        self._boolean_primitive = boolean_primitive

    @property
    def date_time(self):
        """Gets the date_time of this Organization.  # noqa: E501


        :return: The date_time of this Organization.  # noqa: E501
        :rtype: bool
        """
        return self._date_time

    @date_time.setter
    def date_time(self, date_time):
        """Sets the date_time of this Organization.


        :param date_time: The date_time of this Organization.  # noqa: E501
        :type: bool
        """

        self._date_time = date_time

    @property
    def primitive(self):
        """Gets the primitive of this Organization.  # noqa: E501


        :return: The primitive of this Organization.  # noqa: E501
        :rtype: bool
        """
        return self._primitive

    @primitive.setter
    def primitive(self, primitive):
        """Sets the primitive of this Organization.


        :param primitive: The primitive of this Organization.  # noqa: E501
        :type: bool
        """

        self._primitive = primitive

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Organization):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
